//
// -----------------
// Splash Screen DLL
// -----------------
//	Provides a method for the GameFilm engine and CD-Autorun programs to
//	share bitmap resources. To save space, the bitmaps are stored as
//	compressed resources, with a special DLL function provided to
//	decompress the data, set up a DIB from the data (as a DIBSECTION)
//	and return an HBITMAP for that DIB.
//
//	Author: Jack Thornton
//	for CetaSoft / Level Five, Inc.
//	952 Postal Way, Suite 3
//	Vista, CA 92083
//	(619) 631-5855
//
//	Client: Atari Corporation
//	Project: GameFilm Engine
//	Date: 2/24/96
// --------------------------------------------------------------------------

#ifndef _SPLSHDLL_H
#define _SPLSHDLL_H

#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif

// Prototypes for the DLL-provided access functions
BOOL FetchBitmap(UINT index, LPBITMAPINFO *pHdr, LPVOID *pBits, RECT *pDestRect);
void DiscardBitmap(UINT index);

// Indices for bitmaps
#define PIC_SPLASH_SCREEN	    0
#define PIC_BTNPLAY_UNFOCUSED	    1
#define PIC_BTNPLAY_FOCUSED	    2
#define PIC_BTNPLAY_SELECTED	    3
#define PIC_BTNOPTIONS_UNFOCUSED    4
#define PIC_BTNOPTIONS_FOCUSED	    5
#define PIC_BTNOPTIONS_SELECTED     6
#define PIC_BTNEXIT_UNFOCUSED	    7
#define PIC_BTNEXIT_FOCUSED	    8
#define PIC_BTNEXIT_SELECTED	    9
#define PIC_BTNINSTALL_UNFOCUSED    10
#define PIC_BTNINSTALL_FOCUSED	    11
#define PIC_BTNINSTALL_SELECTED     12
#define PIC_BTNCANCEL_UNFOCUSED     13
#define PIC_BTNCANCEL_FOCUSED	    14
#define PIC_BTNCANCEL_SELECTED	    15

#ifdef __cplusplus
}
#endif

#endif	// _SPLSHDLL_H

