#ifndef __DIALOG_H
#define __DIALOG_H
#include "basewin.h"

class Dialog : public BaseWin
{
  public:
	void SelfCenter();
    Dialog();
    Dialog(int resourceID);
    virtual ~Dialog();
    int RunModal(BaseWin* parent, int resourceID);
    int RunModeless(BaseWin* parent, int resourceID);
    void Terminate(int result);
  	BOOL Create();


   static int MessageBox(BaseWin* w, const string& title, const string& msg, int type)
   {
     return ::MessageBox(w?w->GetHWND():0, title.c_str(), msg.c_str(), type);
   }
   int MessageBox(const string& title, const string& msg, int type)
   {
     return MessageBox(this, title, msg, type);
   }

  private:
	int rsrc;
    static BOOL CALLBACK Handler(HWND, UINT, WPARAM, LPARAM);
    int modal;
    int doingProc;
};
#define DECLARE_DIALOG_COMMAND_LOOKUP() \
  public: \
    void Execute(int cmd, int note) \
    { \
      SeekAndExecute(cmdTable, cmd, note); \
    }   \
  private: \
    static CmdAssoc cmdTable[]

#define BEGIN_DIALOG_COMMAND_TABLE(className) \
CmdAssoc className::cmdTable[] = {

#define END_DIALOG_COMMAND_TABLE() { 0, 0 }}

#define BIND_DIALOG_COMMAND(className, fnName, key) \
{ key, (void (Dialog::*)(int,int))&className::fnName },


#endif
