/********************************************************************\

  Methods:
			Open(char *)							// Open File
			Close()

	BOOL	StatusFileOpened()						// File Opended?

\********************************************************************/

#ifndef _FREADERHEAD
#define _FREADERHEAD

#include <windows.h>
#include "SBuffer.h"
#include "FRsrc.h"

// Possible error messages return by ::Open()
#define		SH_BUSY				-1
#define		SH_BUFFER_NA		-2
#define		SH_FILE_NA			-3
#define		SH_ERROR_OPENING	-4

class FileReader {
protected:

	FRSRC		*bigfile;
	long		fileHandle;

public:
			FileReader() { bigfile=NULL; fileHandle=-1; }
			~FileReader() { CloseFile(); }

	BOOL			StatusFileOpened();
	void			CloseFile();

	BOOL __fastcall OpenFileEntry(long entryid);
	BOOL __fastcall OpenFile(long id);
	BOOL __fastcall OpenFile(const char *filename);
	void __fastcall SetArchieveAttrib(FRSRC *rc);

	FRSRC_FILEENTRY *GetFileInformation();
};

inline FRSRC_FILEENTRY *FileReader::GetFileInformation()
{
	if (bigfile && fileHandle!=-1)
		return bigfile->GetFileInformation(fileHandle);
	else
		return NULL;
}

inline BOOL FileReader::StatusFileOpened()
{ 
	return fileHandle==-1 ? FALSE : TRUE ;
}

inline void	FileReader::CloseFile()
{
	if (fileHandle != -1)
	{
		bigfile->CloseFile(fileHandle);
		fileHandle=-1;
	}
}

inline BOOL __fastcall FileReader::OpenFileEntry(long entryid)
{
		if (bigfile==NULL)
			return FALSE;

		CloseFile();
		fileHandle=bigfile->OpenFileEntry(entryid);

		if (fileHandle != -1)
			return TRUE;

		return FALSE;

}

inline BOOL __fastcall FileReader::OpenFile(long id)
{
		if (bigfile==NULL)
			return FALSE;

		CloseFile();
		fileHandle=bigfile->OpenFile(id);

		if (fileHandle != -1)
			return TRUE;

		return FALSE;
}

inline BOOL __fastcall FileReader::OpenFile(const char *filename)
{
		if (bigfile==NULL)
			return FALSE;

		CloseFile();
		fileHandle=bigfile->OpenFile(filename);

		if (fileHandle != -1)
			return TRUE;

		return FALSE;
}

// Assigns a bigfile to this object
inline void __fastcall FileReader::SetArchieveAttrib(FRSRC *rc)
{
		bigfile=rc;
}


#endif
