; =========================================================               
; CSXMMAP.INC: This file contains the includes needed to 
; place memory buffers in the appropriate place, allowing
; for taking advantage of the wrap around buffers in the DSP.
; =========================================================
; Copyright, 1995 Atari Corporation.
; Written for Atari by Highlight Software Solutions.
; =========================================================
; Apr 1996 HMK	Made chnages for GameFilm. Moved some data
;		into DSP RAM for better performance.
; =========================================================


; =========================================================
; CSX_DAT         EQU     D_RAM +(2*1024) ; 2K bytes
; .ORG CSX_DAT                            ; 6k bytes below top of memory
;
;	Make sure we have the output buffer where weant it:

.long
.rept (((D_RAM+(2*1024))-ENDCODEMARK)>>2)
		.dcb.l	1,0
.endr
CSX_DAT:

;============= OBUF_L ===============================================
; This buffer is used to output left channel audio for the isr.
; Size: Must be multiple of 1024 (4 Maxiblock) words (2048 bytes)
OBUF_L:
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 1K bytes

dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 2K bytes


;============= OBUF_R ===============================================
; This buffer is used to output right channel audio for the isr.
; Size: Must be multiple of 1024 (4 Maxiblock) words (2048 bytes)
OBUF_R:
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 1K bytes

dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 2K bytes


;============= IBUF ===============================================
; This buffer is used to fetch packed data from 68K space to DSP.
; Size: Must be 256 (Maxiblock) long words (1024 bytes)  + 10 long words
; for potential worst case header.
IBUF:        
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
 dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 1024 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; HEADER OVERFLOW (16 long words).
; =========== HBUF =================================================
; This smaller buffer is used to store the current maxiblock header.
; Size: Must be maximum CSX Header size moved to longs. 
; Using 10 Longs, this is a small cushion
HBUF:
dc.l    0,0,0,0,0,0,0,0,0,0                     ; 10 longs (40 bytes)

CSX_EOI:                                        ; One word past end of input
dc.l	0					; 1 long (4 bytes)

CSX_HOI:                                        ; Half way pt of input
dc.l	0					; 1 long (4 bytes)

CSX_CHANNEL:
dc.l	0					; stereo (0), mono (1)

; ================ MOVED FROM DRAM into DSP +++ HMK 1/4/96 ===========


CSXIN_HEAD::
	dc.l    silenceBlock

CSXIN_TAIL::
	dc.l    silenceBlock
; ==================================================================
; REGISTERS USED TO INITIALIZE MODE OF CSX IN USE
CSXSETCHAN::
	dc.l	0 		; default to stereo (zero), mono (non-zero)

; ==================================================================
; GLOBAL CPU ARGUMENT LIST

DSP_ARGS::	.dc.l	0,0	; Argument list
DSP_STOP::	.dc.l	0	; Stop flag (set by CPU)
AUDIO_DRIFT::   .dc.l   0       ; Audio drift rate
AUDIO_DESC::    .dc.l   0       ; Audio Data Description-Not used: Can handle only CSX!
ATTEN_SHIFT::   .dc.l   19      ; Attenuation shift value

; ==================================================================

vOverCount::	.dc.l	0	; Count of Voice Over Samples
vOverData::	.dc.l	0 	; Voice Over Data Pointer
audioGain::     .dc.l   $1000   ; Q12 unsigned number

; ==================================================================
; Silence Block Data

silencePointer:: .dc.l	0
silenceSize::	 .dc.l	0

silenceBlock::
	.dc.l	$0E18, 	$0000, 	$FFFF, 	$0036
	.dc.l	$0000,	$0000,	$0000,	$0000
	.dc.l	$0000,	$0000,	$0000,	$0000
	.dc.l	$0000,	$0000,	$0000,	$0000
	.dc.l	$0000,	$0000,	$0000,	$0000
	.dc.l	$0000,	$0000,	$0000,	$0000
silenceEnd:: 

; ==================================================================
; DEBUG REGISTER'S USED TO PRINT DEBUG INFO
CSXDB:
CSXDEBUG1:
dc.l	0					; 1 long
CSXDEBUG2:
dc.l	0					; 1 long
CSXDEBUG3:
dc.l	0					; 1 long
CSXDEBUG4:
dc.l	0					; 1 long
CSXDEBUG5:
dc.l	0					; 1 long
CSXDEBUG6:
dc.l	0					; 1 long
CSXDEBUG7:
dc.l	0					; 1 long
CSXDEBUG8:
dc.l	0					; 1 long
CSXDEBUG9:
dc.l	0					; 1 long
CSXDEBUG10:
dc.l	0					; 1 long
CSXDEBUG11:
dc.l	0					; 1 long
CSXDEBUG12:
dc.l	0					; 1 long
CSXDEBUG13:
dc.l	0					; 1 long
CSXDEBUG14:
dc.l	0					; 1 long

