/********************************************************************\
	Memory Handling 
	by Rudy Mathieu
\********************************************************************/

#ifndef _WINMEMORYHEAD
#define _WINMEMORYHEAD

#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif
#if 1
#define winCalloc(units,size) calloc(units,size)
#define winMalloc(size) calloc(1,size)
#define winFree(ptr) free(ptr)
#else
#define winCalloc(units,size)	winMalloc((units) * (size))
#define winMalloc(size)			GlobalLock(GlobalAlloc(GPTR,(size)))

__inline void __fastcall winFree(void *ptr)
{
	if (ptr)
	{
		HGLOBAL handle;
		if (handle = (HGLOBAL)GlobalHandle(ptr));
		{
			GlobalUnlock(handle);
			GlobalFree(handle);
		}
	}
}
#endif

#ifdef __cplusplus
};
#endif

#endif