//  options.cpp
//  options property sheets
#include "fwl5.h"
#include "resource.h"
#include "propsh.h"
#include "options.h"
#include "regkey.h"

#include <assert.h>

GameOptions globalOptions;

GameOptions::GameOptions() 
  : sourceReg(0)
{
  memset(&od,0, sizeof(od));
}
void GameOptions::SetRegSubKey(const string& sub)
{
  keyName = "Software\\Atari\\GameFilm\\" + sub;
  regkey = RegKey(HKEY_CURRENT_USER,keyName);
  regkey.Open();
  if(!regkey.Opened())
  {
    regkey.Create();
    regkey.SetValue("OPTIONS",(char*)&od,sizeof(od));
  }
  else
  {
    CopyFromRegistry();
  }
  sourceReg=1;
}

void GameOptions::CopyFromRegistry()
{
  regkey.GetValue("OPTIONS",(char*)&od,sizeof(od));
}

GameOptions::~GameOptions() 
{
  regkey.SetValue("OPTIONS",(char*)&od,sizeof(od));
}

string GameOptions::GetPassword(void)
{
  return string(od.password);
}

void GameOptions::SetPassword(string s)
{
  assert(s.length()<=50);
  strcpy(od.password,s.c_str());
}
void GameOptions::CommitRegistry()
{
  if (sourceReg)
  {
    regkey.SetValue("OPTIONS",(char*)&od,sizeof(od));
  }
}
