/*********************************************************************\

		This is the master header for the RAV file format.


This is my new and improved method for handling Audio & Video interleaved
data. This process kills the general nature of regular AVI files.

** ChunkID always preceeds data. **

[AV_FILE] 
	filedata

[AV_VINFO]
	video information (BITMAPINFOHEADER)

[AV_AINFO]
	audio information (WAVEFORMATEX)

[AV_SAMPLE]
	Audio and Video Frame Sample (FrameSampleStr)
		(Audio chuck size is AudioBytesPerSec/framerate)

[AV_AFINFO & AV_VFINFO] Audio & Video Frame Info Chunks not implemented

\*********************************************************************/

#ifndef _RJM_AVIH
#define _RJM_AVIH

#include <io.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <windows.h>
#include <vfw.h>
#include "sptypes.h"

BOOL RAVreadsample(int h, PFrameSampleStr sample, PLONG bytesWritten);
BOOL RAVreadheader(int h, PFileInfoStr buffer);
BOOL RAVappend(int h, LPVOID data, DWORD size);
BOOL RAVaddsample(int h, PFrameSampleStr sample);
BOOL RAVupdateheader(int h, PFileInfoStr rjm);

BOOL RAVupdateheader(int h, PFileInfoStr rjm);
void RAVavi2ravinfo(FileInfoStr *rjm,AVIFILEINFO *ms);

char *		RAVtimecode2text(char *sprintformat, DWORD tc);
TIMECODE 	RAVframe2timecode(DWORD frame,DWORD framesPerSec);

#endif
