#ifndef _SPTYPES
#define _SPTYPES

/* Generic callback is defined this way */
typedef void (* genericCallback)(void *);

/********************************************************************\
						Used by RAV format 
\********************************************************************/
#define		AV_FILE_ID				(WORD)0xf000
#define		AV_FILE_VERSION			(WORD)0x0001

typedef 	DWORD 					TIMECODE;

#pragma pack(push, 1)
typedef struct {
					DWORD 		frame;
					TIMECODE	timecode;
					DWORD		audioSize,videoSize;
					LPVOID      audio,video;
				} FrameSampleStr, *PFrameSampleStr;

typedef struct {
					WORD 				fileID,version;
					WORD 				imageWidth,imageHeight;
					DWORD				totalframes;
					DWORD 				largestAudioBuffer;
					DWORD 				largestVideoBuffer;
					DWORD				fileSize;
					WAVEFORMATEX 		waveInfo;
					WORD				framerate;
					BITMAPINFOHEADER 	bitmapInfo;
				} FileInfoStr, *PFileInfoStr;
#pragma pack(pop)

#define	_FBM(v) 				(0xff & (v)) /* Byte Mask */
#define	RAV_GET_FRAME(v)		_FBM(v)
#define	RAV_GET_SECOND(v)		_FBM(v >> 8)
#define	RAV_GET_MINUTE(v)		_FBM(v >> 16)
#define	RAV_GET_HOUR(v)			_FBM(v >> 24)

#define RAV_MAKE_TIMECODE(h,m,s,f) (_FBM(f) | (_FBM(s) << 8) | (_FBM(m)<<16) | (_FBM(h)<<24))


/********************************************************************\
						Used by Direct Sound
\********************************************************************/
#define	INVALID_VALUE 	0xffffffff

/********************************************************************\
						Used by CWAVE
\********************************************************************/

#define DONE_PLAYING	0x0001
#define SAMPLE_READY	0x0004

#define EOF_REACHED		0x0100

/********************************************************************\
						Used by Smartfile
\********************************************************************/

#define DONE_LOADING	0x0002

#define BUFFER_LOCK		0x0100
#define ERROR_READING 	0x0200
#define READY_TO_WORK	0x0400
#define KILL_THREAD 	0x0800
#define BUFFER_WRAPPED  0x1000
#define BUFFER_FULL		0x2000

/********************************************************************\
						Used by Film 
\********************************************************************/
#define DONE_PLAYING	0x0001
#define DONE_LOADING	0x0002
#define SAMPLE_READY	0x0004

#define ALL_WILL_FIT	0x0100
#define NO_AUDIO_TRACK	0x0200
#define VIDEO_DIFFERENT	0x0400

#define LOOP_FOREVER 	0x7fff

typedef enum {

	SHOT		=0xffff,
	LEADIN		=0xfffe,
	LEADOUT		=0xfffd,
	LOOP		=0xfffc,
	UNKNOWN		=0xfffb

} FILMTYPE;

/********************************************************************\
						Used by Schduler
\********************************************************************/

#define DONE_PLAYING	0x0001
#define KILL_THREAD 	0x0800
#define BUFFER_AVAIL    0x2000
#define LOOP_PLAYING	0x4000
#define CHAIN_NEXT		0x8000

typedef enum {	FIRST,SECOND,THIRD, NONE=-1 } ORDER_NO;

typedef enum { NOFADE,FADEIN,FADEOUT } FADETYPE;

#endif
