/********************************************************************\
	Smart Buffer
	by Rudy Mathieu
\********************************************************************/

#include "SBuffer.h"

// Open Buffer
BOOL __fastcall SmartBuffer::OpenBuffer(long s)
{ 
	CloseBuffer(); 
	size = s << 10; 
	if (size % gChunkSize)
		return FALSE; // Chunk will not evenly divide into bufferSize

	if (  (buffer=(PBYTE)winMalloc(size)) == NULL )
		return FALSE;

	return TRUE;
}

// Return Values:
long __fastcall SmartBuffer::Read(void *ptr, long size)
{
	// Fully loaded but empty means we are done DUDE!!!
	if ( buffer==NULL || BYTESLOADED()==0)
	{
		return BUFFER_EMPTY;// Buffer Empty and Done reading
	}

	// Is this amount of data available?
	if (DataAvailable(size)==TRUE)
    {
		memcpy(ptr,buffer + datastart,bsize1);
		if (bsize2)
			memcpy((char *)ptr+bsize1,buffer,bsize2);
      
		MoveAndWrapPointer(datastart,size);
#ifndef NEVER_SEEKS
		fileptr += size;
#endif
		return size;
    }

	// Is data fully loaded?
	if (StatusLoaded()) 
	{
		/* Read remainder of data */
		BOOL rt = Read(ptr,BYTESLOADED());
		ResetBuffer();
  		return rt;
    } else {
		return BUFFER_BUSY;// Data is not ready yet
	}
}

#ifndef NEVER_SEEKS
BOOL __fastcall SmartBuffer::Seek(long fp)
{
   if (fp >= fileptr && fp < fileptr + BYTESLOADED())
   {  /* Within range to do a Fast Forward Seek */
      int diff = fp - fileptr;
      MoveAndWrapPointer(datastart,diff);
	  fileptr = fp;
	  return TRUE;
   }
   if (fp < fileptr && !(StatusWrapped()))
   {  /* Fast Reverse Seek is legal here */
	  datastart = fp;
	  fileptr = fp;
	  return TRUE;
   }
   return FALSE;
}
#endif