/********************************************************************\

  Methods:
						Loop()					
						ReadSample(PFrameSampleStr)

							  ***** Protected ******
						Link(SmartBuffer *)		Link Buffer
						Unlink()				Unlink Buffer
						_Read();				Read Chunck

\********************************************************************/

#ifndef _RAVSRHEAD
#define _RAVSRHEAD

#include "SHandle.h"
#include "Sptypes.h"

class RAVSampleReader 
{
  SmartGroup			*shandle;		/* Smart Handle */
  int					shandleid;		/* Smart Handle ID */

protected:
  SmartFile 			*buffer;
  PFrameSampleStr     sampleptr;
  int					readStatus;

  long	_Read(void);
  void	Unlink(void) { buffer=NULL; }

public:
  RAVSampleReader()
  {
    //memset(&header,0,sizeof(header));
    sampleptr = NULL;
    buffer = NULL;
    readStatus = 0;
    shandleid = 0;
    shandle = 0;
  }
  virtual ~RAVSampleReader() 
  {
    Unlink(); sampleptr=NULL; 
    shandleid = 0;
    shandle = 0;
  }

  BOOL	Loop(void)
  {
    readStatus = 0;
    if (buffer)
      return buffer->Seek(sizeof(FileInfoStr));

    return FALSE;
  }

  long	__fastcall ReadSample(PFrameSampleStr sample)
  {
    sampleptr = sample;
    return _Read();
  }

  long __fastcall ReadHeader(FileInfoStr* header);
  long __fastcall ReallyReadHeader(FileInfoStr* header);

  long __fastcall GetBufferSize() const 
  {
    return buffer->Size(); 
  }

  BOOL StatusLoaded() const
  {
    if (shandleid != -1)
    {
      return shandle->Data(shandleid)->StatusLoaded();
    }
    return 0;
  }
  FRSRC_FILEENTRY* GetFileInformation()
  {
    if (shandleid != -1)
    {
      return shandle->Data(shandleid)->GetFileInformation(); 
    }
    return 0;
  }
  BOOL CheckBuffer()
  {
    if (shandleid != -1)
    {
      return shandle->Data(shandleid)->Buffer()!=0;
    }
    return 0;
  }

  void CloseBuffer()
  {
    if (shandleid != -1)
    {
      shandle->Close(shandleid);
      shandleid=-1;
    }
  }
  void	__fastcall Link(int id);
  void __fastcall Link(SmartGroup *g);

};

#endif