#include "fwl5.h"
#include "disks.h"
#include "cdbox.h"
#include "navcontr.h"
#include "resource.h"
#include <io.h>

#include "regkey.h"
BOOL Disks::Setup(const string& keyName)
{
  RegKey dir(HKEY_CURRENT_USER, keyName);
  dir.Open();
  if (dir.Opened())
  {
    unsigned newDisks = (unsigned)dir.GetDWORD("MooCount");
    DiskID* newIDs=0;
    unsigned i;
    string newHD;

    if (newDisks==0)
    {
      // special case for old layout:
      // No MooCount key, no labels, no vols.
      // Just one cmoo.
      newDisks=1;
      newIDs = new DiskID[1];
      newIDs[0].path = dir.GetValue("cmoo");
      newIDs[0].volumeName = "";
      newIDs[0].friendlyName = "The Disk";
      newHD = dir.GetValue("hmoo");
    }
    else
    {
      newIDs = new DiskID[newDisks];

      for (i=0; i<newDisks; i++)
      {
        char buf[20];
        wsprintf(buf, "cmoo%d", i);
        newIDs[i].path = dir.GetValue(buf);
        wsprintf(buf, "cvol%d", i);
        newIDs[i].volumeName = dir.GetValue(buf);
        wsprintf(buf, "label%d", i);
        newIDs[i].friendlyName = dir.GetValue(buf);
      }
      newHD = dir.GetValue("hmoo");
    }
    nDisks = newDisks;
    delete [] disks;
    disks = newIDs;
    hd.path = newHD;
    return TRUE;
  }
  return FALSE;
};

BOOL Disks::CheckPresence(int index) const
{
  DiskID diskID = disks[index];//key.GetValue("cvol1");
  string volID = diskID.volumeName;
  string arcFile = diskID.path;//key.GetValue("cmoo1");
  if (!volID.length())
  {
    return (_access(arcFile.c_str(), 0) == 0);
  }
  if (volID.length())
  {
    string cdrpath;
    string volname;
    DWORD volser;
    DWORD fsizemax;
    DWORD flags;
    string filesys;
    cdrpath.resize(128);
    volname.resize(128);
    filesys.resize(128);
    char* cp = strchr(arcFile.c_str(), '\\');
    strncpy((char*)cdrpath.c_str(), arcFile.c_str(), cp-arcFile.c_str()+1);
    cdrpath.c_str()[cp-arcFile.c_str()+1] = 0;
    if (GetVolumeInformation( cdrpath.c_str()
                            , (char*)volname.c_str()
                            , 128
                            , &volser
                            , &fsizemax
                            , &flags
                            , (char*)filesys.c_str()
                            , 128
                            )
       )
    {
      return (volname == volID);
    }
  }
  return FALSE;
}

BOOL Disks::RequestInsertOrQuit(BaseWin* w, int index)
{
  if (!CheckPresence(index))
  {
    CDBox dlg(this, index);
    return dlg.RunModal(w)==IDC_CONTINUE;
  }
  return TRUE;
}
