#ifndef _VOLUMES_H
#define _VOLUMES_H
struct DiskID
{
  string volumeName;
  string friendlyName;
  string path;
};

class BaseWin;

class Disks
{
public:
  Disks()
    : nDisks(0)
    , disks(0)
  {
  }
  ~Disks()
  {
    if (disks) delete [] disks;
  }
  BOOL CheckPresence(int index) const;
  const DiskID& GetCD(unsigned v) const { assert(v<nDisks); return disks[v]; }
  const DiskID& GetHD() const { return hd; }
  BOOL RequestInsertOrQuit(BaseWin* w, int index);
  BOOL Setup(const string& keyName);
  const DiskID& operator[](unsigned v) const { assert(v<nDisks); return disks[v]; }
private:
  unsigned nDisks;
  DiskID* disks;
  DiskID hd;
};


#endif