#ifndef __GAMEWIN
#define __GAMEWIN
#include "window.h"
//#include "navcontr.h"
class NavController;
#include "enabler.h"

class FunkyBar;
class DDBox;
class DDSurf;
class GameWindow : public Window
{
public:
	BOOL QueryClose();
	void IndicateVolume(int idicate);
	void PromptForPause();
	void PromptForResume();
	void EnableResume();
	void DisableResume();
	void DisableCommand(UINT id);
	void EnableCommand(UINT id);
  GameWindow(const char* command_);
  ~GameWindow();
  BOOL Create(void); // overload
  CRect GetPromptArea() const;
  CRect GetClipArea() const;
  void HideMenu();
  virtual int Idle();
  void initTest();
  virtual void Key(int code, int flags);
  BOOL MakeFunkyBar(void);

  virtual int  OnEraseBackground(CDC h) { return 0; }
  BOOL OnCreate();
  virtual void OnDestroy();
  virtual void OnMove(int x, int y);
  virtual void OnSize(int k, int x, int y);
  virtual void MouseDown(const CPoint& place, int flags);
  virtual void OnPaint(const CDC& h, const CRect& update);
  virtual BOOL OnContextMenu(HWND h, const CPoint& where);
  void OnPopup(int,int);
  void OnPause(int,int);
  void OnGo(int,int);
  void OnExitApp(int,int);

  void ShowMenu();
  void SetSmallRect(const CRect& rect);
  void SetLargeRect(const CRect& rect);
  void SetSplashRect(const CRect& rect);
  enum Size { WZ_ZOOM, WZ_NORMAL, WZ_SPLASH };
  void SetWindowSize(Size size);
  void StatusMessage(const string& msg);
  void CheckPrimary();
private:
  NavController* controller;
  DDBox* dd;
  DDSurf* primary;
  DDSurf* back1;
  DDSurf* back2;
  EnabledMap enabledCommands;
  FunkyBar* funkyBar;
  CRect largeRect;
  CRect smallRect;
  CRect splashRect;
  BOOL menuShowing;
  const char* command;
  Size windowState;

  BOOL OnInitMenu(HMENU menu);
  virtual BOOL OtherMessage(UINT msg, WPARAM, LPARAM, LRESULT& res);
  virtual BOOL WantsDialogKeys(); // sometimes yes, sometimes no.

  DECLARE_COMMAND_LOOKUP();
};

#endif