#include "fwl5.h"
#include "plstate.h" // playback state of controller.
#include "navcontr.h"
//#include "fsstate.h"
#include "icstate.h"
#include "dbgtst.h"
//-----------------------------------------------------------------------------
void PlayState::MouseDown(const CPoint&, int)
{
  controller->TakeABranch();
}
//-----------------------------------------------------------------------------
void PlayState::Key(int key, int)
{
  switch (key)
  {
  case VK_SPACE:
  case VK_RETURN:
    controller->TakeABranch();
    break;
  case VK_PAUSE:
    if (pause)
      ResumePlay();
    else
      PausePlay();
    break;
    // For the following keys to work, I had to disable
    // IsDialogMessage during this state.
  case VK_LEFT:
    controller->VolumeSofter();
    break;
  case VK_RIGHT:
    controller->VolumeLouder();
    break;
  default:
    DEBUGSTRING(("weird key\n"));
    break;
  }
}
//-----------------------------------------------------------------------------
static int primed=0;
static DWORD primetime = 0;
void PlayState::Idle()
{
  controller->FileManagement();
  controller->PromptManagement();
  // Plan:
  //  Call scheduler->Manager once, very first time.
  //  Wait several hundred milliseconds, then start calling continuously.
  if (!primed)
  {
    if (primetime==0)
    {
      controller->TimeManagement();
      primetime = GetTickCount();
    }
    else if (GetTickCount()-primetime > 500)
    {
      primed = TRUE;
      controller->TimeManagement();
    }
  }
  else
  {
    if (controller->GameOver())
    {
      SetState(new FinalCreditState(controller));
    }
    else if (!pause)
    {
      controller->TimeManagement();
    }
  }
}
//-----------------------------------------------------------------------------
void PlayState::ResumePlay()
{
  pause = 0;
  controller->ResumePlayback();
}
//-----------------------------------------------------------------------------
void PlayState::PausePlay()
{
  pause = 1;  
  controller->PausePlayback();
}
