#ifndef __PWDIALOG_H
#define __PWDIALOG_H
#include "dialog.h"
#include "restring.h"
#include "resource.h"

class PWDialog : Dialog
{
public:
  PWDialog() 
    : Dialog()
    , instructions1(IDS_PWINST1)
    , instructions2(IDS_PWINST2)
    , noMatchTitle(IDS_PWNOMTITLE)
    , noMatchMsg(IDS_PWNOMMSG)
    , cancelTitle(IDS_PWCANCELTITLE)
    , cancelMsg(IDS_PWCANCELMSG,256)
    , cancelMsg2(IDS_PWCANCELMSG2,256)
    , reasonNull(IDS_PWCANCELNULL)
    , reasonCancel(IDS_PWCANCELCHOSE)
    , noNewPassword(IDS_PWCANCELUNCHANGED)
  {
  }
  int RunModal(BaseWin* parent)
  {
    return Dialog::RunModal(parent,DLG_PASSWORD);
  }
  void OnOkay(int cmd, int note);
  void OnCancel(int cmd, int note);
  void OnEdits(int cmd, int note);

  BOOL OnCreate()
  {
    Initialize();
    return TRUE;
  }
  void Initialize();
  void NoPasswordMessage(const char* reason);
  string GetPassword() const { return password; }

private:

  ResString instructions1;
  ResString instructions2;
  ResString noMatchTitle;
  ResString noMatchMsg;
  ResString cancelTitle;
  ResString cancelMsg;
  ResString cancelMsg2;
  ResString noNewPassword;
  ResString reasonNull;
  ResString reasonCancel;

  string password;
  DECLARE_COMMAND_LOOKUP();
};
#endif