#ifndef _RAVOUTHEAD
#define _RAVOUTHEAD

#include <windows.h>
#include "string.h"
#include "sptypes.h"
#include "render.h"
#include "dsnd.h"
#include "mem.h"
#include "GDISave.h"
#include "Dbgtst.h"

extern HWND thisWindow;

struct VideoFrameST 
{
	DWORD	frame;
	PBYTE	data[1];
};

typedef VideoFrameST *PVideoFrameST;

class RAVOutput {
private:
	GDISave				area;

	Renderer			*renderer;
	DSoundBuffer		*dsound;
	FrameSampleStr		*sample;
	DWORD				sampleSize;
	BOOL				statusPAUSE;

	PVideoFrameST		*videoFrames;		// Array of stored video
	int					nextVideoFrame;		// Next display frame
	int					totalbufferedframes;// Total buffered frames

	int	GetVideoWB(void);
	void DropVideoFrame(void);

public:
	RAVOutput();
	~RAVOutput();
	void Init(void);
	
	Renderer		*Display(void) { return renderer; }
	DSoundBuffer	*Sound(void) { return dsound; }

	BOOL	SampleReady(void) { return sample->audio!=NULL; }

	void	Close(void);
	BOOL	__fastcall Open(Renderer *r, DSoundBuffer *s, int ssize);
	BOOL	__fastcall Load(FrameSampleStr *s);

	void	DisplayFrame(void);
	
	void	RefreshVideo(void);
	void	UpdateAV(void);

	void	Pause(void);
	void	Resume(void) { statusPAUSE = FALSE; }
};

#endif
