#ifndef __TQUEUE_H
#define __TQUEUE_H

template <class T> class TQUEUE
{
  struct Qnode
  {
    T* data;
    Qnode* next;
    Qnode* prev;
  };
public:
  TQUEUE()
  {
    head = 0;
    tail = 0;
    depth = 0;
  }
  ~TQUEUE()
  {
    Flush();
  }
  void Flush()
  {
    Qnode* n = head;
    while (n)
    {
      delete n->data;
      head = head->next;
      delete n;
      n = head;
    }
  }
  void Put(T* thing)
  {
    Qnode* n = new Qnode;
    n->data = thing;
    n->next = head;
    n->prev = 0;
    if (head) head->prev = n;
    head = n;
    if (!tail) tail = n; 
    depth++;
  }
  T* Get()
  {
    Qnode* n = tail;
    if (n)
    {
      tail = tail->prev;
      T* p = n->data;
      delete n;
      depth--;
      return p;
    }
    else
    {
      return 0;
    }
  }
  T* Peek()
  {
    return tail->data;
  }
  int Remove(T* t)
  {
    Qnode* n = head;
    while (n)
    {
      if (n->data == t)
      {
        break;
      }
      n = n->next;
    }
    if (n)
    {
      if (n->prev) n->prev->next = n->next;
      if (n->next) n->next->prev = n->prev;
      if (n==head) head = n->next;
      if (n==tail) tail = n->prev;
      delete t;
      delete n;
      depth--;
    }
    return n != 0;
  }
  unsigned GetDepth() const
  {
    return depth;
  }
private:
  Qnode* head;
  Qnode* tail;
  unsigned depth;
};

#endif