#include <windows.h>
#include <process.h>
unsigned long _beginthread
  ( void( *start_address )( void * )//Start address of routine that begins execution of new thread
  , unsigned stack_size //Stack size for new thread or 0
  , void *arglist //Argument list to be passed to new thread or NULL
  );

struct backBlock
{
  HANDLE file;
  struct Command
  {
    void* dest;
    long bytes;
    int seek;
    int pulse;
    int terminate;
  };
  Command requested;
  int request; // incremented by controlling thread
  HANDLE doneEvent;
  int handled; // incremented by thread
  Command pending;
  HANDLE goEvent;
  BOOL Done()
  {
    return handled==request;
  }
  BOOL Pending()
  {
    return handled != request;
  }
};
void BackgroundFileReading(void* d)
{
  backBlock& status = *(backBlock*)d;
  while (1)
  {
    WaitForSingleObject(status.goEvent, INFINITE);
    status.pending = status.requested;
    if (status.pending.terminate)
    {
      break;
    }
    else if (status.pending.seek)
    {
      SetFilePointer(status.file, status.pending.bytes, 0, FILE_BEGIN);
      PulseEvent(status.doneEvent);
      status.handled = status.request;
    }
    else
    {
      DWORD read;
      ReadFile(status.file, status.pending.dest, status.pending.bytes, &read, 0);
      PulseEvent(status.doneEvent);
      status.handled = status.request;
    }
  }
}