#include "fwl5.h"
#include "voxover.h"
#include "cpnodes.h"
#include "film.h"
#include <stdexcpt.h>
#include "options.h"

static CPSegment* lSeg=0;
static BOOL lOption = FALSE;
extern GameOptions globalOptions;
void VoiceOverManager::Manage()
{
  int cstate = globalOptions.VoiceoversOn();

  if (lOption && !cstate)
  {
    vox.Stop();
    vox.Close();
  }
  lOption = cstate;
}
#include "clcontex.h"
void VoiceOverManager::NotifyOn(const ClipContext& context)
{
  BOOL loop = context.loop;
  CPSegment* seg = &context.node->data.film.pTracks[context.trackIndex].pSegments[context.segIndex];
  // gets called when segment starts
  int enabled = globalOptions.VoiceoversOn();
  int difEnabled;
  if (loop)
  {
    difEnabled = context.passCount > 0;
  }
  else
  {
    difEnabled = TRUE;
  }

  // branchEnabled if !loop
  // branchEnabled if loop && (disabledBranches & (1<<kSegment))
  int branchEnabled = !(disabledBranches & (1<<context.segIndex));
  if (seg->voiceOver && seg != lSeg && branchEnabled)
  {
    lSeg = seg;
    vox.Stop();
    vox.Close();
    if (enabled && difEnabled)
    {
      if (vox.Open(seg->voiceOver))
      {
        vox.SetVolume(-600); // atten 6 db
        vox.Play(1);
      }
      else
      {
        throw logic_error("Didn't make a sound");
      }
    }
  }
}

void VoiceOverManager::NotifyOff()
{
  lSeg = 0;
  // gets called when segment ends.
}

// Called by File manager to give us the sound names.
void VoiceOverManager::SetupFiles()
{
  vox.SetReader(new BigFileWaveReader);
}

void VoiceOverManager::EnableAllBranches()
{
  disabledBranches = 0;
}

void VoiceOverManager::DisableBranch(int b)
{
  disabledBranches |= (1<<b);
}